/*************************************************
* Zeus CMD - C++ Tutorial 8 : Pointers           *
* By Grant James (ZEUS)                          *
* http://www.zeuscmd.com                         *
*************************************************/
#include <iostream>
#include <stdlib.h>

using namespace std;

int main()
{
	// Different Character Pointers
	//------------------------------

	char *pointerToString = "Hello";
	// pointerToString[3] = 'r'; - RUNTIME ERROR

	const char *pointerToConstantString = "Hello";
	// pointerToConstantString[3] = 'r'; // COMPILE ERROR

	char * const constantPointerToString = "Hello";
	// constantPointerToString[1] = 't'; // RUNTIME ERROR

	// constantPointerToString = "Hello2"; // COMPILE ERROR

	const char * const constantPointerToConstantString = "Hello";
	//constantPointerToConstantString[2] = 'r'; // COMPILE ERROR
	//constantPointerToConstantString = "Hello2"; // COMPILE ERROR

	cout << pointerToConstantString << endl;

	// Pointer Declarations
	//----------------------
	int x = 0;
	int *px = NULL;
	char *str = "Hello World";

	// Size of pointers
	cout << "Size of pointer : " 
		<< sizeof(px) << endl;
	cout << "Size of str : "
		<< sizeof(str) << endl;

	// Values
	//--------
	cout << "Value of x : "
		<< x << endl;
	cout << "Value of px : "
		<< px << endl;

	// Addresses
	//-----------
	cout << "Address of x : " 
		<< &x << endl;
	cout << "Address of px : "
		<< &px << endl;
	
	// Information pointed to
	//------------------------
	cout << "Value pointed to by str : "
		<< *str << endl;
	cout << "Value pointed to by str+1 : "
		<< *(str + 1) << endl;

	system("sleep 1");

	return 0;
}
